<template>
  <div id="userprofile" class="container">
    <b-row>
      <div class="col-sm-2"></div>
      <div class="col-sm-8">
        <b-form @submit.stop.prevent="onSubmit">
          <h4 style="text-align: left">{{ $t("userListHeadline") }}:</h4>
          <coscine-form-group
            labelFor="Title"
            :label="$t('titleLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <multiselect
              id="Title"
              v-model="$v.form.Title.$model"
              :options="titles"
              :multiple="false"
              label="displayName"
              track-by="displayName"
              :placeholder="$t('MultiselectPlaceholderTitle')"
              :selectLabel="$t('MultiselectSelectEnter')"
            >
              <span slot="noResult">{{ $t("MultiselectNoResults") }}</span>
              <span slot="noOptions">{{ $t("MultiselectNoOptions") }}</span>
            </multiselect>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Givenname"
            :label="$t('givennameLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-input
              id="Givenname"
              v-model="$v.form.Givenname.$model"
              :state="
                $v.form.Givenname.$dirty ? !$v.form.Givenname.$error : null
              "
              :placeholder="$t('givenname')"
            />
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Surname"
            :label="$t('surnameLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-input
              id="Surname"
              v-model="$v.form.Surname.$model"
              :state="$v.form.Surname.$dirty ? !$v.form.Surname.$error : null"
              :placeholder="$t('surname')"
            />
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Email"
            :label="$t('emailLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-input
              id="Email"
              v-model="$v.form.EmailAddress.$model"
              :state="
                $v.form.EmailAddress.$dirty
                  ? !$v.form.EmailAddress.$error
                  : null
              "
              :placeholder="$t('email')"
              @change="updateEmailHint()"
            />
            <div id="emailHint">{{ emailHint }}</div>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Organization"
            :label="$t('organizationLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <multiselect
              v-if="externalUser"
              id="Organization"
              v-model="selectedExternalOrganisation"
              :options="ror"
              :multiple="false"
              :loading="loadingOrganizations"
              label="displayName"
              track-by="displayName"
              :placeholder="$t('organization')"
              @search-change="triggerFetchOptions"
            >
              <template slot="singleLabel" slot-scope="props">
                {{ props.option.displayName }}
              </template>
              <template slot="option" slot-scope="props">
                {{ props.option.displayName }}
              </template>
              <template slot="noOptions">
                {{ $t("MultiselectNoOptionsOrganization") }}
              </template>
            </multiselect>
            <multiselect
              v-else
              id="Organization"
              v-model="organizations"
              :options="organizations"
              :multiple="true"
              label="displayName"
              track-by="displayName"
              :placeholder="$t('organization')"
              :disabled="true"
            >
            </multiselect>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Institute"
            :label="$t('instituteLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <b-form-input
              v-if="externalUser"
              id="Institute"
              v-model="$v.form.Institute.$model"
              :state="
                $v.form.Institute.$dirty ? !$v.form.Institute.$error : null
              "
              type="text"
              :placeholder="$t('institute')"
            >
            </b-form-input>
            <multiselect
              v-else
              id="Institute"
              v-model="institutes"
              :options="institutes"
              :multiple="true"
              label="displayName"
              track-by="displayName"
              :placeholder="$t('institute')"
              :disabled="true"
            >
            </multiselect>
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            labelFor="Discipline"
            :label="$t('disciplineLabel')"
            :isLoading="isLoading"
            type="input"
          >
            <multiselect
              id="Discipline"
              v-model="$v.form.Disciplines.$model"
              :options="disciplines"
              :multiple="true"
              :label="disciplineLabel"
              :track-by="disciplineLabel"
              :placeholder="$t('discipline')"
            >
              <template slot="singleLabel" slot-scope="props">
                {{ props.option[disciplineLabel] }}
              </template>
              <template slot="option" slot-scope="props">
                {{ props.option[disciplineLabel] }}
              </template>
            </multiselect>
          </coscine-form-group>
          <access-token></access-token>
          <div class="h-divider"></div>
          <h4 style="text-align: left">{{ $t("userpreferences") }}:</h4>
          <coscine-form-group
            :mandatory="true"
            labelFor="Language"
            :label="$t('languageLabel')"
            :isLoading="isLoading"
            type="button"
          >
            <b-form-radio-group
              class="bv-no-focus-ring"
              id="Language"
              v-model="$v.form.Language.id.$model"
              :options="languages"
              name="radios-stacked"
              stacked
            ></b-form-radio-group>
          </coscine-form-group>
          <div class="h-divider"></div>
          <h4 style="text-align: left">{{ $t("connectedaccounts") }}:</h4>
          <coscine-form-group
            :mandatory="true"
            :label="$t('orcidLabel')"
            :isLoading="isLoading"
            type="button"
          >
            <b-button
              variant="secondary"
              class="float-left"
              name="orcidConnect"
              @click.prevent="clickConnect('orcid')"
              :disabled="orcidConnected || !externalAuthenticatorsLoaded"
              >{{
                orcidConnected || !externalAuthenticatorsLoaded
                  ? $t("connected")
                  : $t("connect")
              }}</b-button
            >
          </coscine-form-group>
          <coscine-form-group
            :mandatory="true"
            :label="$t('shibbolethLabel')"
            :isLoading="isLoading"
            type="button"
          >
            <b-button
              variant="secondary"
              class="float-left"
              name="shibbolethConnect"
              @click.prevent="clickConnect('shibboleth')"
              :disabled="shibbolethConnected || !externalAuthenticatorsLoaded"
              >{{
                shibbolethConnected || !externalAuthenticatorsLoaded
                  ? $t("connected")
                  : $t("connect")
              }}</b-button
            >
          </coscine-form-group>
          <coscine-form-group>
            <b-button
              type="submit"
              variant="secondary"
              class="float-right"
              name="save"
              ref="saveBtn"
              @click.prevent="clickSave"
              :disabled="
                $v.form.$invalid || savingProfile || !$v.form.$anyDirty
              "
            >
              <b-iconstack
                animation="spin"
                v-if="savingProfile"
                aria-hidden="true"
              >
                <b-icon
                  stacked
                  icon="dot"
                  aria-hidden="true"
                  shift-v="4"
                ></b-icon>
                <b-icon
                  stacked
                  icon="dot"
                  aria-hidden="true"
                  shift-v="-4"
                ></b-icon>
                <b-icon
                  stacked
                  icon="dot"
                  aria-hidden="true"
                  shift-h="4"
                ></b-icon>
                <b-icon
                  stacked
                  icon="dot"
                  aria-hidden="true"
                  shift-h="-4"
                ></b-icon>
              </b-iconstack>
              {{ $t("save") }}</b-button
            >
          </coscine-form-group>
        </b-form>
      </div>
      <div class="col-sm-2"></div>
    </b-row>
  </div>
</template>

<script lang="ts">
import Vue from "vue";
import VueI18n from "vue-i18n";

import { validationMixin } from "vuelidate";
import { required, email } from "vuelidate/lib/validators";

import {
  UserApi,
  TitleApi,
  LanguageApi,
  OrganizationApi,
  DisciplineApi,
  ContactChangeApi,
} from "@coscine/api-connection";
import { LanguageUtil } from "@coscine/app-util";

import Multiselect from "vue-multiselect";
import "vue-multiselect/dist/vue-multiselect.min.css";

import { CoscineFormGroup } from "@coscine/component-library";
import "@coscine/component-library/dist/index.css";

import AccessToken from "./components/AccessToken.vue";

import { BootstrapVueIcons } from "bootstrap-vue";

Vue.use(VueI18n);
Vue.use(BootstrapVueIcons);

export default Vue.extend({
  mixins: [validationMixin],
  name: "UserProfile",
  components: {
    Multiselect,
    CoscineFormGroup,
    AccessToken,
  },
  validations: {
    form: {
      Title: {},
      Givenname: {
        required,
      },
      Surname: {
        required,
      },
      EmailAddress: {
        email,
        required,
      },
      Organization: {},
      Institute: {},
      Disciplines: {},
      Language: {
        id: {},
      },
    },
  },
  data() {
    return {
      isLoading: true,
      savingProfile: false,
      currentUserComponent: "UserProfileComponent",
      externalUser: true,
      disciplineLabel: "displayNameEn",
      form: {
        Givenname: "",
        Surname: "",
        EmailAddress: "",
        Title: "",
        Organization: "",
        Institute: "",
        Disciplines: [] as Record<string, unknown>[],
        Language: {
          id: "",
        },
      },
      selectedExternalOrganisation: null as Record<string, unknown> | null,
      titles: [] as Record<string, unknown>[],
      languages: [] as Record<string, unknown>[],
      organizations: [] as Record<string, unknown>[],
      ror: [] as Record<string, unknown>[],
      institutes: [] as Record<string, unknown>[],
      disciplines: [] as Record<string, unknown>[],
      Language: [] as Record<string, unknown>[],
      shibbolethConnected: false,
      orcidConnected: false,
      externalAuthenticatorsLoaded: false,
      queryTimer: 0,
      loadingOrganizations: false,
      confirmationPending: false,
      emailHint: "",
      currentEmail: "",
    };
  },
  created() {
    if (LanguageUtil.getLanguage() === "en") {
      this.disciplineLabel = "displayNameEn";
    } else {
      this.disciplineLabel = "displayNameDe";
    }

    DisciplineApi.getDisciplines((response: any) => {
      for (const datum of response.data) {
        this.disciplines.push(datum);
      }
      this.$v.$reset();
    });

    TitleApi.getTitles((response: any) => {
      for (const title of response.data) {
        this.titles.push(title);
      }
      this.$v.$reset();
    });
    LanguageApi.getLanguages((response: any) => {
      for (const language of response.data) {
        if (language.abbreviation === "en" && this.form.Language.id === "") {
          this.form.Language = language;
        }
        this.languages.push({ text: language.displayName, value: language.id });
      }
      this.$v.$reset();
    });
    this.isLoading = true;
    UserApi.getUser((response: any) => {
      {
        this.isLoading = false;
        this.form.Givenname = response.data.givenname;
        this.form.Surname = response.data.surname;
        this.form.EmailAddress = response.data.emailAddress;
        this.currentEmail = response.data.emailAddress;
        this.form.Title =
          response.data.title === null ? "" : response.data.title;
        if (response.data.language !== null) {
          this.form.Language = response.data.language;
        }
        this.form.Organization =
          response.data.organization === null ? "" : response.data.organization;
        this.form.Institute = response.data.institute;
        this.form.Disciplines = [];
        for (const discipline of response.data.disciplines) {
          this.form.Disciplines.push(discipline);
        }
        if (
          this.form.EmailAddress === null ||
          this.form.EmailAddress === undefined ||
          this.form.EmailAddress.length === 0
        ) {
          this.emailHint = this.$t("emailNoAddress").toString();
        }
        ContactChangeApi.getStatus((response: any) => {
          if (response.data.length >= 1) {
            this.confirmationPending = true;
            this.emailHint = this.$t("emailPendingConfirmation").toString();
          }
        });
        this.handleExternalAuthenticators(response.data.externalAuthenticators);
        this.updateSelectedExternalOrganisation();
      }
    });

    OrganizationApi.getOrganizationsWhereUserIsMember((response: any) => {
      for (const orgElement of response.data.data) {
        const org = orgElement as any;
        if (org.url.indexOf("#") !== -1) {
          // if does contain a # its a sub level organisation
          this.institutes.push(org);
        } else {
          // if does not contain a # its a top level organisation
          this.organizations.push(org);
        }
      }
      if (this.organizations.length > 0 && this.institutes.length > 0) {
        this.externalUser = false;
      }
    });
  },
  methods: {
    async clickConnect(provider: string) {
      await UserApi.setAndReturnMergeToken(provider);
      location.href = "/coscine/api/Coscine.Api.STS/account/logout";
    },
    updateEmailHint() {
      let hint = "";
      if (this.form.EmailAddress.length === 0) {
        hint += this.$t("emailNoAddress").toString();
      }
      if (this.confirmationPending) {
        hint = this.$t("emailPendingConfirmation").toString();
      }
      this.emailHint = hint;
    },
    clickSave() {
      this.$v.$touch();
      if (
        !this.$v.form.$anyError &&
        !this.$v.form.$invalid &&
        this.$v.form.$anyDirty
      ) {
        this.savingProfile = true;
        if (
          this.$v.form.EmailAddress &&
          this.$v.form.EmailAddress.$model !== this.currentEmail
        ) {
          ContactChangeApi.emailChange(
            JSON.stringify(this.form.EmailAddress),
            () => {
              this.currentEmail = this.form.EmailAddress;
              this.confirmationPending = true;
              this.updateEmailHint();
              this.makeToast(
                this.$t("emailChangedMessage").toString(),
                this.$t("emailChangedTitle").toString()
              );
            }
          );
        }
        UserApi.updateUser(
          this.form,
          () => {
            this.$v.form.$reset();
            this.savingProfile = false;
            this.makeToast(
              this.$t("toastMessages.saveSuccessfulMessage").toString(),
              this.$t("toastMessages.saveSuccessfulTitle").toString()
            );
          },
          () => {
            this.savingProfile = false;
            this.makeToast(
              this.$t("toastMessages.saveFailedMessage").toString(),
              this.$t("toastMessages.saveFailedTitle").toString()
            );
          }
        );
      }
    },
    handleExternalAuthenticators(
      externalAuthenticators: Array<{ id: string; displayName: string }>
    ) {
      externalAuthenticators.forEach((externalAuthenticator) => {
        const externalAuthenticatorName =
          externalAuthenticator.displayName.toLowerCase();
        switch (externalAuthenticatorName) {
          case "shibboleth":
            this.shibbolethConnected = true;
            break;
          case "orcid":
            this.orcidConnected = true;
            break;
        }
      });
      this.externalAuthenticatorsLoaded = true;
    },
    makeToast(text = "Message", givenTitle = "Title") {
      this.$bvToast.toast(text, {
        title: givenTitle,
        autoHideDelay: 5000,
        toaster: "b-toaster-bottom-right",
        noCloseButton: true,
      });
    },
    updateSelectedExternalOrganisation() {
      if (this.form.Organization !== "") {
        if (this.ror.length > 0) {
          for (const ro of this.ror) {
            if (ro.url === this.form.Organization) {
              this.selectedExternalOrganisation = ro;
              this.$v.$reset();
            }
          }
        }
        if (
          this.selectedExternalOrganisation === null ||
          this.selectedExternalOrganisation === undefined ||
          this.selectedExternalOrganisation.url !== this.form.Organization
        ) {
          OrganizationApi.getOrganization(
            this.form.Organization,
            (response: any) => {
              const newRor = [];
              newRor.push(response.data.data[0]);
              this.ror = newRor;
              this.selectedExternalOrganisation = this.ror[0];
              this.$v.$reset();
            }
          );
        }
      }
    },
    triggerFetchOptions(search: string) {
      clearTimeout(this.queryTimer);
      if (search.length < 3) {
        return;
      }
      this.queryTimer = window.setTimeout(
        () => this.fetchOrganizationOptions(search),
        1000
      );
    },
    fetchOrganizationOptions(search: string) {
      this.loadingOrganizations = true;
      const newOrganizations = [] as Record<string, unknown>[];
      if (this.selectedExternalOrganisation !== null) {
        newOrganizations.push(this.selectedExternalOrganisation);
      }
      OrganizationApi.getROR(
        search,
        (response: any) => {
          for (const org of response.data.data) {
            newOrganizations.push(org);
          }
          this.ror = newOrganizations;
          this.loadingOrganizations = false;
        },
        () => {
          this.loadingOrganizations = false;
        }
      );
      this.updateSelectedExternalOrganisation();
    },
  },
});
</script>

<style>
#userprofile {
  font-family: "Avenir", Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
  margin-top: 20px;
}
#userprofile h4 {
  color: #000;
  font-family: "Avenir", Helvetica, Arial, sans-serif;
}
#userprofile .form-group.mandatory .col-form-label:after {
  content: " *";
  color: #a70619;
}
#userprofile .multiselect {
  min-height: calc(1.4em + 0.75rem + 2px);
}
#userprofile .multiselect__input {
  border: 0px;
  min-height: calc(1.4em + 0.75rem + 2px);
}
#userprofile .multiselect__tags {
  border-radius: 0px;
}
#userprofile .col-form-label {
  font-weight: bold;
}
.h-divider {
  margin-top: 5px;
  margin-bottom: 10px;
  height: 1px;
  width: 100%;
  border-top: 1px solid #bebbbb;
}
.bv-no-focus-ring {
  width: 5%;
}
.multiselect__tag {
  background-color: #00549f !important;
}
.multiselect__option--highlight {
  background-color: #00549f !important;
  background: #00549f !important;
}
.multiselect__option--selected.multiselect__option--highlight {
  background-color: #a70619 !important;
}
.multiselect__tag-icon:focus,
.multiselect__tag-icon:hover {
  background-color: #a70619 !important;
}
#emailHint {
  color: red;
  text-align: left;
}
</style>
